package com.link.core.parserplugin;

import java.lang.reflect.Method;

public abstract class AbstractScriptParser {
   protected static final String TARGET = "target";
   protected static final String ARGS = "args";
   protected static final String USER_VAL = "userVal";
   protected static final String RET_VAL = "retVal";
   protected static final String HASH = "hash";
   protected static final String EMPTY = "empty";

   public abstract void addFunction(String name, Method method);

   public abstract <T> T getElValue(String exp, Object target, Object[] arguments, Object retVal, boolean hasRetVal, Object userVal, boolean hasUserVal, Class<T> valueType) throws Exception;

   public String getStringElValue(String keyEL, Object target, Object[] arguments, Object retVal, boolean hasRetVal, Object userVal, boolean hasUserVal) throws Exception {
      return (String)this.getElValue(keyEL, target, arguments, retVal, hasRetVal, userVal, hasUserVal, String.class);
   }

   public Boolean getBooleanElValue(String keyEL, Object target, Object[] arguments, Object retVal, boolean hasRetVal, Object userVal, boolean hasUserVal) throws Exception {
      return (Boolean)this.getElValue(keyEL, target, arguments, retVal, hasRetVal, userVal, hasUserVal, Boolean.class);
   }
}
